/// <reference types="googlemaps" />
import { ElementRef, EventEmitter, NgZone, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MapsAPILoader } from '@agm-preview/core';
import { Location } from '../interfaces/location.interface';
import PlaceResult = google.maps.places.PlaceResult;
import AutocompleteOptions = google.maps.places.AutocompleteOptions;
export declare enum Appearance {
    STANDARD = "standard",
    FILL = "fill",
    OUTLINE = "outline",
    LEGACY = "legacy"
}
export declare class MatGoogleMapsAutocompleteComponent implements OnInit {
    private _mapsAPILoader;
    private _ngZone;
    searchElementRef: ElementRef;
    addressLabelText: string;
    placeholderText: string;
    requiredErrorText: string;
    invalidErrorText: string;
    appearance: string | Appearance;
    address: PlaceResult | string;
    country: string | string[];
    placeIdOnly?: boolean;
    strictBounds?: boolean;
    types?: string[];
    type?: string;
    autoCompleteOptions: AutocompleteOptions;
    onChange: EventEmitter<PlaceResult | string | null>;
    onAutocompleteSelected: EventEmitter<PlaceResult>;
    onLocationSelected: EventEmitter<Location>;
    private onNewPlaceResult;
    private addressValidator;
    addressSearchControl: FormControl;
    constructor(_mapsAPILoader: MapsAPILoader, _ngZone: NgZone);
    ngOnInit(): void;
    initGoogleMapsAutocomplete(): void;
    onQuery(event: any): void;
    private resetAddress;
}
