/// <reference types="googlemaps" />
import { ElementRef, EventEmitter, NgZone, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MapsAPILoader } from '@agm-preview/core';
import { Location } from '../interfaces/location.interface';
import PlaceResult = google.maps.places.PlaceResult;
import AutocompleteOptions = google.maps.places.AutocompleteOptions;
export declare class MatGoogleMapsAutocompleteDirective implements OnInit {
    platformId: string;
    elemRef: ElementRef;
    mapsAPILoader: MapsAPILoader;
    private _ngZone;
    address: PlaceResult | string;
    country: string | string[];
    placeIdOnly?: boolean;
    strictBounds?: boolean;
    types?: string[];
    type?: string;
    autoCompleteOptions: AutocompleteOptions;
    onChange: EventEmitter<PlaceResult | string | null>;
    onAutocompleteSelected: EventEmitter<PlaceResult>;
    onLocationSelected: EventEmitter<Location>;
    private onNewPlaceResult;
    private addressValidator;
    addressSearchControl: FormControl;
    constructor(platformId: string, elemRef: ElementRef, mapsAPILoader: MapsAPILoader, _ngZone: NgZone);
    ngOnInit(): void;
    initGoogleMapsAutocomplete(): void;
}
